Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.google.common.collect
Class ImmutableBiMap<K,V>

    java.lang.Object
      com.google.common.collect.ImmutableMap<K,V>
          com.google.common.collect.ImmutableBiMap<K,V>

All Implemented Interfaces:
  BiMap<K,V>, Serializable, Map<K,V>

    public abstract class ImmutableBiMap<K,V>

extends ImmutableMap<K,V>
implements BiMap<K,V>

An immutable `BiMap` with reliable user-specified iteration order. Does not permit null keys or values. An `ImmutableBiMap` and its inverse have the same iteration ordering.

An instance of `ImmutableBiMap` contains its own data and will never change. `ImmutableBiMap` is convenient for `public static final` maps ("constant maps") and also lets you easily make a "defensive copy" of a bimap provided to your class by a caller.

Note: Although this class is not final, it cannot be subclassed as it has no public or protected constructors. Thus, instances of this class are guaranteed to be immutable.

Author:
  Jared Levy
See Also:
  Serialized Form

Nested Class Summary
`static class` | `ImmutableBiMap.Builder<K,V>` A builder for creating immutable bimap instances, especially `public static final` bimaps ("constant bimaps").

Nested classes/interfaces inherited from interface java.util.Map
`Map.Entry<K,V>`

Method Summary
`static
`<K,V> ImmutableBiMap.Builder<K,V>`
` | `builder()` Returns a new builder.
`boolean` | `containsKey(Object key)` Returns `true` if this map contains a mapping for the specified key.
`boolean` | `containsValue(Object value)` Returns `true` if this map maps one or more keys to the specified value.
`static
`<K,V> ImmutableBiMap<K,V>`
` | `copyOf(Map<? extends K,? extends V> map)` Returns an immutable bimap containing the same entries as `map`.
`ImmutableSet<Map.Entry<K,V>>` | `entrySet()` Returns an immutable set of the mappings in this map.
`boolean` | `equals(Object object)` Indicates whether some other object is "equal to" this one.
`V` | `forcePut(K key, V value)` Guaranteed to throw an exception and leave the bimap unmodified.
`V` | `get(Object key)` Returns the value to which the specified key is mapped, or `null` if this map contains no mapping for the key.
`int` | `hashCode()` Returns a hash code value for the object.
`abstract ImmutableBiMap<V,K>` | `inverse()` Returns the inverse view of this bimap, which maps each of this bimap's values to its associated key.
`boolean` | `isEmpty()` Returns `true` if this map contains no key-value mappings.
`ImmutableSet<K>` | `keySet()` Returns an immutable set of the keys in this map.
`static
`<K,V> ImmutableBiMap<K,V>`
` | `of()` Returns the empty bimap.
`static
`<K,V> ImmutableBiMap<K,V>`
` | `of(K k1, V v1)` Returns an immutable bimap containing a single entry.
`static
`<K,V> ImmutableBiMap<K,V>`
` | `of(K k1, V v1, K k2, V v2)` Returns an immutable map containing the given entries, in order.
`static
`<K,V> ImmutableBiMap<K,V>`
` | `of(K k1, V v1, K k2, V v2, K k3, V v3)` Returns an immutable map containing the given entries, in order.
`static
`<K,V> ImmutableBiMap<K,V>`
` | `of(K k1, V v1, K k2, V v2, K k3, V v3, K k4, V v4)` Returns an immutable map containing the given entries, in order.
`static
`<K,V> ImmutableBiMap<K,V>`
` | `of(K k1, V v1, K k2, V v2, K k3, V v3, K k4, V v4, K k5, V v5)` Returns an immutable map containing the given entries, in order.
`int` | `size()` Returns the number of key-value mappings in this map.
`String` | `toString()` Returns a string representation of the object.
`ImmutableSet<V>` | `values()` Returns an immutable set of the values in this map.

Methods inherited from class com.google.common.collect.ImmutableMap
`clear, put, putAll, remove`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Methods inherited from interface com.google.common.collect.BiMap
`put, putAll`

Methods inherited from interface java.util.Map
`clear, remove`

Method Detail

### of

    public static <K,V> ImmutableBiMap<K,V> of()

  Returns the empty bimap.

### of

    public static <K,V> ImmutableBiMap<K,V> of(K k1,
                                               V v1)

  Returns an immutable bimap containing a single entry.

### of

    public static <K,V> ImmutableBiMap<K,V> of(K k1,
                                               V v1,
                                               K k2,
                                               V v2)

  Returns an immutable map containing the given entries, in order.

  Throws:
    `IllegalArgumentException` - if duplicate keys or values are added

### of

    public static <K,V> ImmutableBiMap<K,V> of(K k1,
                                               V v1,
                                               K k2,
                                               V v2,
                                               K k3,
                                               V v3)

  Returns an immutable map containing the given entries, in order.

  Throws:
    `IllegalArgumentException` - if duplicate keys or values are added

### of

    public static <K,V> ImmutableBiMap<K,V> of(K k1,
                                               V v1,
                                               K k2,
                                               V v2,
                                               K k3,
                                               V v3,
                                               K k4,
                                               V v4)

  Returns an immutable map containing the given entries, in order.

  Throws:
    `IllegalArgumentException` - if duplicate keys or values are added

### of

    public static <K,V> ImmutableBiMap<K,V> of(K k1,
                                               V v1,
                                               K k2,
                                               V v2,
                                               K k3,
                                               V v3,
                                               K k4,
                                               V v4,
                                               K k5,
                                               V v5)

  Returns an immutable map containing the given entries, in order.

  Throws:
    `IllegalArgumentException` - if duplicate keys or values are added

### builder

    public static <K,V> ImmutableBiMap.Builder<K,V> builder()

  Returns a new builder. The generated builder is equivalent to the builder created by the `ImmutableBiMap.Builder` constructor.

### copyOf

    public static <K,V> ImmutableBiMap<K,V> copyOf(Map<? extends K,? extends V> map)

  Returns an immutable bimap containing the same entries as `map`. If `map` somehow contains entries with duplicate keys (for example, if it is a `SortedMap` whose comparator is not consistent with equals), the results of this method are undefined.

  Note: If `map` is an `ImmutableBiMap`, the given map itself will be returned.

  Throws:
    `IllegalArgumentException` - if two keys have the same value
    `NullPointerException` - if any key or value in `map` is null

### inverse

    public abstract ImmutableBiMap<V,K> inverse()

  Returns the inverse view of this bimap, which maps each of this bimap's values to its associated key. The two bimaps are backed by the same data; any changes to one will appear in the other.

  Note:There is no guaranteed correspondence between the iteration order of a bimap and that of its inverse.

  The inverse of an `ImmutableBiMap` is another `ImmutableBiMap`.

  Specified by:
    `inverse` in interface `BiMap<K,V>`
  Returns:
    the inverse view of this bimap

### containsKey

    public boolean containsKey(@Nullable
                               Object key)

  Description copied from interface: `java.util.Map`
  Returns `true` if this map contains a mapping for the specified key. More formally, returns `true` if and only if this map contains a mapping for a key `k` such that `(key==null ? k==null : key.equals(k))`. (There can be at most one such mapping.)

  Specified by:
    `containsKey` in interface `Map<K,V>`
  Overrides:
    `containsKey` in class `ImmutableMap<K,V>`
  Parameters:
    `key` - key whose presence in this map is to be tested
  Returns:
    `true` if this map contains a mapping for the specified key

### containsValue

    public boolean containsValue(@Nullable
                                 Object value)

  Description copied from interface: `java.util.Map`
  Returns `true` if this map maps one or more keys to the specified value. More formally, returns `true` if and only if this map contains at least one mapping to a value `v` such that `(value==null ? v==null : value.equals(v))`. This operation will probably require time linear in the map size for most implementations of the `Map` interface.

  Specified by:
    `containsValue` in interface `Map<K,V>`
  Specified by:
    `containsValue` in class `ImmutableMap<K,V>`
  Parameters:
    `value` - value whose presence in this map is to be tested
  Returns:
    `true` if this map maps one or more keys to the specified value

### entrySet

    public ImmutableSet<Map.Entry<K,V>> entrySet()

  Description copied from class: `ImmutableMap`
  Returns an immutable set of the mappings in this map. The entries are in the same order as the parameters used to build this map.

  Specified by:
    `entrySet` in interface `Map<K,V>`
  Specified by:
    `entrySet` in class `ImmutableMap<K,V>`
  Returns:
    a set view of the mappings contained in this map

### get

    public V get(@Nullable
                 Object key)

  Description copied from interface: `java.util.Map`
  Returns the value to which the specified key is mapped, or `null` if this map contains no mapping for the key.

  More formally, if this map contains a mapping from a key `k` to a value `v` such that `(key==null ? k==null : key.equals(k))`, then this method returns `v`; otherwise it returns `null`. (There can be at most one such mapping.)

  If this map permits null values, then a return value of `null` does not necessarily indicate that the map contains no mapping for the key; it's also possible that the map explicitly maps the key to `null`. The `containsKey` operation may be used to distinguish these two cases.

  Specified by:
    `get` in interface `Map<K,V>`
  Specified by:
    `get` in class `ImmutableMap<K,V>`
  Parameters:
    `key` - the key whose associated value is to be returned
  Returns:
    the value to which the specified key is mapped, or `null` if this map contains no mapping for the key

### keySet

    public ImmutableSet<K> keySet()

  Description copied from class: `ImmutableMap`
  Returns an immutable set of the keys in this map. These keys are in the same order as the parameters used to build this map.

  Specified by:
    `keySet` in interface `Map<K,V>`
  Specified by:
    `keySet` in class `ImmutableMap<K,V>`
  Returns:
    a set view of the keys contained in this map

### values

    public ImmutableSet<V> values()

  Returns an immutable set of the values in this map. The values are in the same order as the parameters used to build this map.

  Specified by:
    `values` in interface `BiMap<K,V>`
  Specified by:
    `values` in interface `Map<K,V>`
  Specified by:
    `values` in class `ImmutableMap<K,V>`
  Returns:
    a collection view of the values contained in this map

### forcePut

    public V forcePut(K key,
                      V value)

  Guaranteed to throw an exception and leave the bimap unmodified.

  Specified by:
    `forcePut` in interface `BiMap<K,V>`
  Parameters:
    `key` - the key with which the specified value is to be associated
    `value` - the value to be associated with the specified key
  Returns:
    the value which was previously associated with the key, which may be `null`, or `null` if there was no previous entry
  Throws:
    `UnsupportedOperationException` - always

### isEmpty

    public boolean isEmpty()

  Description copied from interface: `java.util.Map`
  Returns `true` if this map contains no key-value mappings.

  Specified by:
    `isEmpty` in interface `Map<K,V>`
  Overrides:
    `isEmpty` in class `ImmutableMap<K,V>`
  Returns:
    `true` if this map contains no key-value mappings

### size

    public int size()

  Description copied from interface: `java.util.Map`
  Returns the number of key-value mappings in this map. If the map contains more than `Integer.MAX_VALUE` elements, returns `Integer.MAX_VALUE`.

  Specified by:
    `size` in interface `Map<K,V>`
  Returns:
    the number of key-value mappings in this map

### equals

    public boolean equals(@Nullable
                          Object object)

  Description copied from class: `java.lang.Object`
  Indicates whether some other object is "equal to" this one.

  The `equals` method implements an equivalence relation on non-null object references:

  - It is reflexive: for any non-null reference value `x`, `x.equals(x)` should return `true`.
  - It is symmetric: for any non-null reference values `x` and `y`, `x.equals(y)` should return `true` if and only if `y.equals(x)` returns `true`.
  - It is transitive: for any non-null reference values `x`, `y`, and `z`, if `x.equals(y)` returns `true` and `y.equals(z)` returns `true`, then `x.equals(z)` should return `true`.
  - It is consistent: for any non-null reference values `x` and `y`, multiple invocations of `x.equals(y)` consistently return `true` or consistently return `false`, provided no information used in `equals` comparisons on the objects is modified.
  - For any non-null reference value `x`, `x.equals(null)` should return `false`.

  The `equals` method for class `Object` implements the most discriminating possible equivalence relation on objects; that is, for any non-null reference values `x` and `y`, this method returns `true` if and only if `x` and `y` refer to the same object (`x == y` has the value `true`).

  Note that it is generally necessary to override the `hashCode` method whenever this method is overridden, so as to maintain the general contract for the `hashCode` method, which states that equal objects must have equal hash codes.

  Specified by:
    `equals` in interface `Map<K,V>`
  Overrides:
    `equals` in class `ImmutableMap<K,V>`
  Parameters:
    `object` - the reference object with which to compare.
  Returns:
    `true` if this object is the same as the obj argument; `false` otherwise.
  See Also:
    `Object.hashCode()`, `Hashtable`

### hashCode

    public int hashCode()

  Description copied from class: `java.lang.Object`
  Returns a hash code value for the object. This method is supported for the benefit of hashtables such as those provided by `java.util.Hashtable`.

  The general contract of `hashCode` is:

  - Whenever it is invoked on the same object more than once during an execution of a Java application, the `hashCode` method must consistently return the same integer, provided no information used in `equals` comparisons on the object is modified. This integer need not remain consistent from one execution of an application to another execution of the same application.
  - If two objects are equal according to the `equals(Object)` method, then calling the `hashCode` method on each of the two objects must produce the same integer result.
  - It is not required that if two objects are unequal according to the `Object.equals(java.lang.Object)` method, then calling the `hashCode` method on each of the two objects must produce distinct integer results. However, the programmer should be aware that producing distinct integer results for unequal objects may improve the performance of hashtables.

  As much as is reasonably practical, the hashCode method defined by class `Object` does return distinct integers for distinct objects. (This is typically implemented by converting the internal address of the object into an integer, but this implementation technique is not required by the JavaTM programming language.)

  Specified by:
    `hashCode` in interface `Map<K,V>`
  Overrides:
    `hashCode` in class `ImmutableMap<K,V>`
  Returns:
    a hash code value for this object.
  See Also:
    `Object.equals(java.lang.Object)`, `Hashtable`

### toString

    public String toString()

  Description copied from class: `java.lang.Object`
  Returns a string representation of the object. In general, the `toString` method returns a string that "textually represents" this object. The result should be a concise but informative representation that is easy for a person to read. It is recommended that all subclasses override this method.

  The `toString` method for class `Object` returns a string consisting of the name of the class of which the object is an instance, the at-sign character ``@`', and the unsigned hexadecimal representation of the hash code of the object. In other words, this method returns a string equal to the value of:

  >      getClass().getName() + '@' + Integer.toHexString(hashCode())

  Overrides:
    `toString` in class `ImmutableMap<K,V>`
  Returns:
    a string representation of the object.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD